<?

function formatDate($txt,$stamp) {
	global $BLXS;
	$t = preg_replace(
		array(
			"/MON/",
			"/Mon/",
			"/mon/",
			"/DAY/",
			"/Day/",
			"/day/",
			"/MIN/i",
			"/SEC/i",
			"/DD/i",
			"/D/i",
			"/MM/i",
			"/M/i",
			"/YYYY/i",
			"/YY/i",
			"/hh/i",
			"/h/i"),
		array(
			"~~~@1~~~",
			"~~~@2~~~",
			"~~~@3~~~",
			"~~~#1~~~",
			"~~~#2~~~",
			"~~~#3~~~",
			date("i",$stamp),
			date("s",$stamp),
			date("d",$stamp),
			date("j",$stamp),
			date("m",$stamp),
			date("n",$stamp),
			date("Y",$stamp),
			date("y",$stamp),
			date("H",$stamp),
			date("G",$stamp)
			),
			$txt);

	$mon = strtolower($BLXS['months'][date("n",$stamp)]);
	$t = ereg_replace("~~~@1~~~",strtoupper($mon),$t);
	$t = ereg_replace("~~~@2~~~",ucwords($mon),$t);
	$t = ereg_replace("~~~@3~~~",$mon,$t);
	
	$day = strtolower($BLXS['days'][date("w",$stamp)]);
	$t = ereg_replace("~~~#1~~~",strtoupper($day),$t);
	$t = ereg_replace("~~~#2~~~",ucwords($day),$t);
	$t = ereg_replace("~~~#3~~~",$day,$t);
	return $t;
	}


function publishPage($blg, $list, $archivFrom) {
	global $BLXS, $blogs, $authors;
	
	$fn = $blg['indextemplate'];
	$ttl = $blg['name'];
	$desc = $blg['desc'];
	$indexPath = $blg['indexrelpath'];
	$archPer = $blg['archivperiod'];
	$archPrefix = $blg['archivprefix'];

	$archPath = $blg['archivrelpath'];
	$x = strrpos($archPath,"/");
	$archPath1 = substr($archPath,0,$x+1);
	$archPath2 = substr($archPath,$x+1);
	
	$fp = fopen($fn,"r") or errDie($BLXS['Err_FileOpen'] . " ($fn)");
	$tmpl = fread($fp,filesize($fn)) or errDie($BLXS['Err_FileRead'] . " ($fn)");
	fclose($fp) or errDie($BLXS['Err_FileClose'] . " ($fn)");
	

	// parse template

	$tmpl = ereg_replace("%bx_title%",$ttl,$tmpl);
	$tmpl = ereg_replace("%bx_description%",$desc,$tmpl);
	$tmpl = ereg_replace("%bx_day_archivelink%",$archPath,$tmpl);
	
	$date = trim(ereg_replace(".*%bx_update([^%]*)%.*","\\1",$tmpl));
	$date = formatDate($date,time());
	$tmpl = ereg_replace("%bx_update[^%]*%",$date,$tmpl);

	$x = split("%bx_day%",$tmpl);
	$pg_hdr = $x[0];
	$rest = $x[1];
	$x = split("%bx_day_end%",$rest);
	$pg_day = $x[0];
	$pg_ftr = $x[1];
	
	if ($pg_day) {
		$tmpl = $pg_day;
		$x = split("%bx_item%",$tmpl);
		$pg_day_hdr = $x[0];
		$rest = $x[1];
		$x = split("%bx_item_end%",$rest);
		$pg_item = $x[0];
		$pg_day_ftr = $x[1];
		}
	else {
		$x = split("%bx_item%",$tmpl);
		$pg_hdr = $x[0];
		$rest = $x[1];
		$x = split("%bx_item_end%",$rest);
		$pg_item = $x[0];
		$pg_ftr = $x[1];
		}


	// fill in template
	
	$buff = $pg_hdr;

	$prevday = '';
	reset($list);
	while(list(,$l) = each($list)) {
		$stamp = $l[0];
		$group = $l[1];
		$authID = $l[2];
		$author = $authors[$authID]['name'];
		$email = $authors[$authID]['e-mail'];
		$thisday = date('yyyy-m-d',$stamp);
		
		if ($pg_day) {
			if ($prevday!=$thisday) {
				if ($prevday) {
					$buff .= $pg_day_ftr;
					}
				$date = trim(ereg_replace(".*%bx_date([^%]*)%.*","\\1",$pg_day_hdr));
				$date = formatDate($date,$stamp);
				$buff .= ereg_replace("%bx_date[^%]*%",$date,$pg_day_hdr);
				}
			}
		
		$body = $pg_item;

		$body = ereg_replace("%bx_item_id%","$stamp",$body);
		$body = ereg_replace("%bx_item_author%",$author,$body);
		$body = ereg_replace("%bx_item_mail%",$email,$body);
		$body = ereg_replace("%bx_item_authormail%","<a href='mailto:$email'>$author</a>",$body);

		getPeriod($stamp, $archPer, $d1, $d2);
		$archivURL = getArchiveFname($archPath1, $archPath2, $archPrefix, $d1);

		$body = ereg_replace("%bx_item_permalink%","$archivURL#$stamp",$body);
		$date = trim(ereg_replace(".*%bx_date([^%]*)%.*","\\1",$body));
		$date = formatDate($date,$stamp);
		$body = ereg_replace("%bx_date[^%]*%",$date,$body);
		
		$itemtext = getItemHTML(readItem($stamp));
		$defttl = trim(ereg_replace(".*%bx_item_autotitle([^%]*)%.*","\\1",$body));
		$body = ereg_replace("%bx_item_autotitle([^%]*)%", getAutotitle($itemtext,$defttl),$body);
		$maxchar = trim(ereg_replace(".*%bx_item_autopreview([^%]*)%.*","\\1",$body));
		$body = ereg_replace("%bx_item_autopreview([^%]*)%", getItemPreview($itemtext,$maxchar),$body);

		$body = ereg_replace("%bx_item_body%",$itemtext,$body);

		$buff .= $body;

		$prevday = $thisday;
		}

	if ($pg_day) $buff .= $pg_day_ftr;

	$buff .= $pg_ftr;

	if ($archivFrom)
		$fn = getArchiveFname($archPath1, $archPath2, $archPrefix, $archivFrom);
	else
		$fn = $indexPath;
	$fp = fopen($fn,"w") or errDie($BLXS['Err_FileOpen'] . " ($fn)");
	fwrite($fp,$buff) or errDie($BLXS['Err_FileWrite'] . " ($fn)");
	fclose($fp) or errDie($BLXS['Err_FileClose'] . " ($fn)");

	ePar( $BLXS['Publ_WasPublished'] . ": " . makeLink("$ttl ($fn)", $fn) );

	}

function publishArchive($blg) {
	global $BLXS, $blogs, $items;
	
	$fn = $blg['archivtemplate'];
	$ttl = $blg['name'];
	$desc = $blg['desc'];
	$gr = $blg['groups'];
	$per = $blg['archivperiod'];
	$archPrefix = $blg['archivprefix'];

	$archPath = $blg['archivrelpath'];
	$x = strrpos($archPath,"/");
	$archPath1 = substr($archPath,0,$x+1);
	$archPath2 = substr($archPath,$x+1);

	$fp = fopen($fn,"r") or errDie($BLXS['Err_FileOpen'] . " ($fn)");
	$tmpl = fread($fp,filesize($fn)) or errDie($BLXS['Err_FileRead'] . " ($fn)");
	fclose($fp) or errDie($BLXS['Err_FileClose'] . " ($fn)");
	
	// parse template

	$tmpl = ereg_replace("%bx_title%",$ttl,$tmpl);
	$tmpl = ereg_replace("%bx_description%",$desc,$tmpl);
	
	$x = split("%bx_archiveitem%",$tmpl);
	$pg_hdr = $x[0];
	$rest = $x[1];
	$x = split("%bx_archiveitem_end%",$rest);
	$pg_item = $x[0];
	$pg_ftr = $x[1];

	// fill in template
	
	$buff = $pg_hdr;

	reset($items);
	while(list(,$l) = each($items)) {
		$stamp = $l[0];
		getPeriod($stamp,$per,$d1,$d2);
		$from = "$d1";
		$to = "$d2";
		if ($stamp>=$from && $stamp<=$to && ($gr=='all' || $gr==$l[1]) )
			$archs[$d1] = $d1;
		}

	while(list(,$l) = each($archs)) {
		$body = $pg_item;
		$archivURL = getArchiveFname($archPath1, $archPath2, $archPrefix, $l);
		$body = ereg_replace("%bx_archivelink%",$archivURL,$body);
		$date = trim(ereg_replace(".*%bx_date([^%]*)%.*","\\1",$body));
		$date = formatDate($date,$l);
		$body = ereg_replace("%bx_date[^%]*%",$date,$body);
		$buff .= $body;
		}

	$buff .= $pg_ftr;

	$fn = $archPath;
	$fp = fopen($fn,"w") or errDie($BLXS['Err_FileOpen'] . " ($fn)");
	fwrite($fp,$buff) or errDie($BLXS['Err_FileWrite'] . " ($fn)");
	fclose($fp) or errDie($BLXS['Err_FileClose'] . " ($fn)");

	ePar( $BLXS['Publ_WasPublished'] . ": " . makeLink("$ttl - ".$BLXS['archive']." ($fn)", $fn) );

	}

function getArchiveFname($pre,$post,$mask,$d) {
	$dd = date("d",$d);
	$mm = date("m",$d);
	$yy = date("y",$d);
	$yyyy = date("Y",$d);
	$fn = $mask;
	$fn = ereg_replace('YYYY',$yyyy,$fn);
	$fn = ereg_replace('YY',$yy,$fn);
	$fn = ereg_replace('MM',$mm,$fn);
	$fn = ereg_replace('DD',$dd,$fn);
	return $pre.$fn.$post;
	}

function getPeriod($stamp,$per,&$d1,&$d2) {
	global $week_starts_moday;
	$d = null;
	$sDate = getdate($stamp);
	if ($per=='W') {
		$wd = $sDate["wday"];
		if ($week_starts_moday) $wd = ($wd+6)%7;
		$day = $sDate["mday"]-$wd;
		$d1 = mktime(0,0,0,$sDate["mon"],$day,$sDate["year"]);
		$d2 = mktime(23,59,59,$sDate["mon"],$day+7,$sDate["year"]);
		}
	elseif ($per=='M') {
		$d1 = mktime(0,0,0,$sDate["mon"],1,$sDate["year"]);
		$d2 = mktime(23,59,59,$sDate["mon"]+1,0,$sDate["year"]);
		}
	elseif ($per=='Y') {
		$d1 = mktime(0,0,0,1,1,$sDate["year"]);
		$d2 = mktime(23,59,59,12,31,$sDate["year"]);
		}
	else {
		$d1 = null;
		$d2 = null;
		}
	}

function getAutotitle($HTML,$default) {
	for ($i=1;$i<=6;$i++) {
		if (eregi(".*<h".$i."[^>]*>([^<]*)</h".$i."[^>]*>.*",$HTML,$r) ) {
			return $r[1];
			}
		}
	return $default;
	}

?>